### prioritaetswarteschlange.py
### Stellt die zur Verwaltung einer Prioritaetswarteschlange
### notwendigen Funktionen bereit.
### Benoetigt ein Vergleichspraedikat vor , das hier
### beispielhaft mit verschiedenen Varianten realisiert ist.

from funktionen import first,last,cons

### ===== fuegeEinenEin =====
# fuegt ein Element in die Prio-Schlange ein
# benötigt das Praedikat vor
def fuegeEinenEin(einer, vor, priows):
    if len(priows)==0: return [einer]
    if vor(einer, first(priows)):
        return cons(einer, []+priows)
    return cons(first(priows),
                fuegeEinenEin(einer, vor, priows[1:]))

### ===== fuegeAlleEin =====
# fuegt alle uebergebenen Elemente in die Prio-Schlange ein
def fuegeAlleEin(alle, vor , priows):
    for eines in alle:
        priows=fuegeEinenEin(eines, vor, priows)
    return priows

# Tests:
### ===== vor =====
### -> Einfach Zahlen
##def vor(zahl_1, zahl_2): return zahl_1 < zahl_2
##print(fuegeEinenEin(10, vor, [1, 11, 21])) # -> [1, 10, 11, 21]
##print(fuegeEinenEin(33, vor, [1, 11, 21])) # -> [1, 10, 11, 21]
##print(fuegeAlleEin([33, 0, 10], vor , [1, 11, 21])) # -> [0, 1, 10, 11, 21, 33]

### -> Strings
##def vor(string_1, string_2): return string_1 < string_2
##print(fuegeEinenEin("hund", vor, ["aal", "katze", "ziege"]))
##print(fuegeAlleEin (["hund", "ziege", "aal"], vor, ["amsel", "katze", "tiger"]))

### -> Wege in Graphen mit der Aktuellen Laenge am Kopf
##def vor(weg_1, weg_2): return first(weg_1) < first(weg_2)
##print(fuegeEinenEin([43, 'M', 'I'], vor, [[34, 'B', 'I'], [40, 'C', 'I'], [65, 'H', 'I']]))
##print(fuegeAlleEin ([[60, 'X', 'B', 'I'], [103, 'A', 'B', 'I'], [64, 'H', 'B', 'I']], vor , [[40, 'C', 'I'], [43, 'M', 'I'], [55, 'P', 'I'], [65, 'H', 'I']]))

### -> Kanten in Graphen mit der Laenge an dritter Position
##def vor(kante_1, kante_2): return first(kante_1) < first(kante_2)
##print(fuegeEinenEin([60, 'G', 'E'], vor, [[30, 'B', 'H'], [69, 'A', 'B']]))
##print(fuegeAlleEin ([[69, 'A', 'B'], [36, 'A', 'D'], [22, 'A', 'N'], [36, 'A', 'M']], vor , []))
